#include "../../../lib/std.mi"
#include "../../../lib/pldir.mi"

Function updatedisplay();

Global layout mainnormal;
Global button play, pause, next, prev, stop;
Global Group infogroup, seekergroup;
Global Layer border,illum;
Global Text time, time2, artistT, titleT, albumT, numT, alternateT;
Global Vis visu;
Global Timer SongTimeT,Blender;
Global Int fullTime, cacheTime,i;
Global String newArtist, newTitle;


updatedisplay()
{
 string pre_title = System.getPlayItemMetaDataString("Title");
 string pre_artist = System.getPlayItemMetaDataString("Artist");
 string pre_album = System.getPlayItemMetaDataString("Album");

 if ((pre_title == "") || (pre_artist == ""))
 {
	titleT.hide();
	artistT.hide();
	albumT.hide();

	alternateT.setText("Nullsoft Winamp3 version 3.0");
	alternateT.show();
 }
 else
 {
	titleT.show();
	artistT.show();
	// Bug bypass using show and hide
	if (pre_album != "")
	albumT.show();
	else
	albumT.hide();

	alternateT.hide();
 }

 titleT.setText(pre_title);
 artistT.setText(pre_artist);
 albumT.setText(pre_album);

}

System.onScriptLoaded()
{
  Layout mainnormal = getContainer("Main").getLayout("normal");

  Pause = mainnormal.getObject("Pause");
  Play = mainnormal.getObject("Play");
  next = mainnormal.getObject("Next");
  prev = mainnormal.getObject("prev");
  stop = mainnormal.getObject("Select");

  infogroup = System.getContainer("main").getLayout("normal").getObject("infowindow");
  seekergroup = System.getContainer("main").getLayout("normal").getObject("seekerwindow");
  border = infogroup.getObject("seekerborder");
  time = seekergroup.getObject("timer");
  time2 = seekergroup.getObject("timer2");

  illum = mainnormal.getObject("illuminator");
  illum.setalpha(0);

  artistT = infogroup.getObject("songArtist");
  titleT = infogroup.getObject("songTitle");
  albumT = infogroup.getObject("songAlbum");
  numT = infogroup.getObject("songNum");

  alternateT = infogroup.getObject("alternate_ticker");
  alternateT.hide();

  Pause.hide();
  Play.hide();
  //border.hide();
  time.hide();
  time2.hide();
  //visu.hide();

  SongTimeT = new timer;
  SongTimeT.setDelay(100);
  SongTimeT.start();

  if (getplayitemstring() != "")
  {
    Pause.show();
    //border.show();
    time.show();
    time2.show();
    //visu.show();
  }
  else
  {
    Play.show();
  }

  UpdateDisplay();

  PlDir.showCurrentlyPlayingEntry();
}

System.onTitlechange(String newTitle)
{
  UpdateDisplay();
}

Prev.onLeftClick()
{
  UpdateDisplay();
}

Next.onLeftClick()
{
  UpdateDisplay();
}

Stop.onLeftClick()
{
  if (System.getPrivateInt("iPod-Menu","IsOn",0) == 0)
  {
    System.Stop();
    UpdateDisplay();
  }
}


SongTimeT.onTimer()
{
  cacheTime = getPosition();
  fullTime = getPlayItemLength();

  time.setText(integerToTime(cacheTime));
  time2.setText("-" + integerToTime(fulltime-cacheTime));
}

// If winamp is playing, hides the play button and shows pause
System.onPlay()
{
  Play.hide();
  Pause.show();
  //border.show();
  time.show();
  time2.show();
  //visu.show();
}


// If winamp is paused, hides pause and shows play
System.onPause()
{
  Play.show();
  Pause.hide();
}

// If winamp is stopped, shows play and hides pause
System.onStop()
{
  Play.show();
  Pause.hide();
  //border.hide();
  time.hide();
  time2.hide();
  //visu.hide();
}


// After paused and button is again pressed starting play, will show pause and hide play
System.onresume()
{
  Play.hide();
  Pause.show();
}